// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UScriptStruct.h"

#include <memory>
#include <string>

using std::wstring;

namespace Sourcify
{	
	class ISCW_UUserDefinedStruct : public virtual ISCW_UScriptStruct
	{
	public:
		virtual ~ISCW_UUserDefinedStruct() = default;

		virtual std::shared_ptr<ISCW_UUserDefinedStruct> ToUUserDefinedStructPtr() = 0;
		virtual std::shared_ptr<const ISCW_UUserDefinedStruct> ToUUserDefinedStructPtr() const = 0;

		virtual ISCW_UObjectPtr GetEditorData() const = 0;
	};

	using ISCW_UUserDefinedStructConstPtr = std::shared_ptr<const ISCW_UUserDefinedStruct>;
	using ISCW_UUserDefinedStructPtr = std::shared_ptr<ISCW_UUserDefinedStruct>;
} // namespace Sourcify